package com.landray.kmss.sys.attachment.util;

import com.landray.kmss.sys.restservice.server.model.SysRestserviceServerMain;
import com.landray.kmss.util.SignUtil;
import com.landray.kmss.sys.restservice.server.model.SysRestserviceServerPolicy;
import com.landray.kmss.util.ArrayUtil;
import com.landray.kmss.sys.restservice.server.service.ISysRestserviceServerMainService;
import com.landray.kmss.sys.authentication.token.Token;
import com.landray.kmss.sys.config.loader.ConfigLocationsUtil;
import com.landray.kmss.sys.authentication.token.TokenGenerator;
import java.net.URLEncoder;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsCloudUtil;
import com.landray.kmss.sys.organization.model.SysOrgPerson;
import java.text.SimpleDateFormat;
import com.landray.kmss.util.DateUtil;
import java.util.Date;
import javax.imageio.stream.ImageInputStream;
import javax.imageio.ImageReader;
import com.landray.kmss.common.exception.KmssRuntimeException;
import com.landray.kmss.web.upload.FormFile;
import com.landray.kmss.sys.log.util.oper.IUserUpdateDetailOper;
import com.landray.kmss.sys.log.util.oper.UserOperContentHelper;
import com.landray.kmss.sys.log.util.UserOperHelper;
import com.landray.kmss.sys.attachment.forms.SysAttWaterMarkForm;
import java.awt.Color;
import com.landray.kmss.util.UserUtil;
import com.landray.kmss.sys.mobile.util.MobileUtil;
import java.awt.Graphics2D;
import java.awt.FontMetrics;
import java.io.ByteArrayInputStream;
import java.io.OutputStream;
import java.awt.image.RenderedImage;
import javax.imageio.ImageIO;
import java.io.ByteArrayOutputStream;
import java.awt.Stroke;
import java.awt.BasicStroke;
import java.awt.image.BufferedImage;
import java.awt.Rectangle;
import java.awt.Dimension;
import sun.font.FontDesignMetrics;
import java.awt.Font;
import com.landray.kmss.common.model.IBaseModel;
import com.landray.kmss.sys.appconfig.model.SysAppConfig;
import java.io.FileInputStream;
import com.landray.kmss.framework.util.PluginConfigLocationsUtil;
import org.apache.commons.io.FilenameUtils;
import java.io.InputStream;
import com.landray.kmss.util.ResourceUtil;
import com.landray.kmss.sys.filestore.location.interfaces.ISysFileLocationProxyService;
import com.landray.kmss.sys.filestore.model.SysAttFile;
import com.landray.kmss.sys.filestore.location.util.SysFileLocationUtil;
import com.landray.kmss.sys.filestore.service.ISysAttUploadService;
import com.landray.kmss.sys.attachment.model.SysAttBase;
import com.landray.kmss.sys.filestore.model.SysFileConvertQueue;
import com.landray.kmss.sys.filestore.service.ISysFileConvertQueueService;
import com.landray.kmss.common.dao.HQLInfo;
import java.util.Iterator;
import java.util.Collections;
import java.util.Comparator;
import java.text.DecimalFormat;
import net.sf.json.JSONObject;
import javax.servlet.http.HttpServletRequest;
import com.landray.kmss.sys.filestore.model.SysFileViewerParam;
import java.util.List;
import com.landray.kmss.sys.filestore.util.SysFileStoreUtil;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.framework.plugin.core.config.IExtension;
import com.landray.kmss.framework.service.plugin.Plugin;
import java.util.HashMap;
import com.landray.kmss.util.SpringBeanUtil;
import org.slf4j.LoggerFactory;
import java.util.Map;
import com.landray.kmss.sys.filestore.service.ISysFileConvertDataService;
import org.slf4j.Logger;

public class SysAttViewerUtil
{
    public static final String unConvertedUrl = "/sys/attachment/viewer/resource/common/images/unConverted.png";
    private static Logger logger;
    private static ISysFileConvertDataService convertDataService;
    private static Map<String, FileViewer> extensionViewers;
    
    static {
        SysAttViewerUtil.logger = LoggerFactory.getLogger(SysAttViewerUtil.class);
        SysAttViewerUtil.convertDataService = (ISysFileConvertDataService)SpringBeanUtil.getBean("sysFileConvertDataService");
    }
    
    private static Map<String, FileViewer> getAllViewers() {
        if (SysAttViewerUtil.extensionViewers == null) {
            SysAttViewerUtil.extensionViewers = new HashMap<String, FileViewer>();
            final IExtension[] allViewers = Plugin.getExtensions("com.landray.kmss.sys.filestore", "*", "viewer");
            if (allViewers != null && allViewers.length > 0) {
                FileViewer fileViewer = null;
                IExtension[] array;
                for (int length = (array = allViewers).length, i = 0; i < length; ++i) {
                    final IExtension viewer = array[i];
                    fileViewer = new FileViewer(null);
                    fileViewer.setViewerKey(Plugin.getParamValue(viewer, "viewerKey").toString());
                    fileViewer.setViewerPath(Plugin.getParamValue(viewer, "viewerPath").toString());
                    final String[] extName = getSupportedExtNames(viewer);
                    fileViewer.setExtName(extName);
                    fileViewer.setOrder(Integer.valueOf(Plugin.getParamValue(viewer, "order").toString()));
                    SysAttViewerUtil.extensionViewers.put(fileViewer.getViewerKey(), fileViewer);
                }
            }
        }
        return SysAttViewerUtil.extensionViewers;
    }
    
    private static String[] getSupportedExtNames(final IExtension viewer) {
        final Object[] values = Plugin.getParamValues(viewer, "extName").toArray();
        final String[] result = new String[values.length];
        for (int i = 0; i < values.length; ++i) {
            result[i] = values[i].toString();
        }
        return result;
    }
    
    public static String getExtName(final String fdFileName) {
        return StringUtil.isNotNull(fdFileName) ? fdFileName.substring(fdFileName.lastIndexOf(".") + 1) : "";
    }
    
    public static String getFileViewerKey(final SysAttMain sysAttMain) throws Exception {
        String viewerKey = "";
        final boolean oldConvertSuccessUseHTMLView = SysFileStoreUtil.isOldConvertSuccessUseHTML();
        final List<SysFileStoreUtil.FileConverter> fileConverters = SysFileStoreUtil.getFileConverters(getExtName(sysAttMain.getFdFileName()), sysAttMain.getFdModelName(), oldConvertSuccessUseHTMLView);
        final List<SysFileViewerParam> convertedParamsList = getConvertedParams(sysAttMain);
        final Map<String, FileViewer> allViewers = getAllViewers();
        final FileViewer fv = getViewer(convertedParamsList, "", allViewers, fileConverters, getExtName(sysAttMain.getFdFileName()));
        if (fv != null && StringUtil.isNotNull(fv.getConverterKey())) {
            viewerKey = fv.getConverterKey();
        }
        return viewerKey;
    }
    
    public static String getViewerPath(final SysAttMain attMain, final List<SysFileViewerParam> convertedParamsList, final List<SysFileStoreUtil.FileConverter> fileConverters, final HttpServletRequest request) throws Exception {
        String viewerPath = "";
        final String viewerKey = request.getParameter("viewer");
        final Map<String, FileViewer> allViewers = getAllViewers();
        SysAttViewerUtil.logger.debug("viewer:" + viewerKey);
        final FileViewer fv = getViewer(convertedParamsList, viewerKey, allViewers, fileConverters, getExtName(attMain.getFdFileName()));
        if (fv != null) {
            viewerPath = fv.getViewerPath();
            final String viewerParam = fv.getViewerParam();
            request.setAttribute("viewerParam", (Object)viewerParam);
            SysAttViewerUtil.logger.debug("viewerParam:" + viewerParam);
            request.setAttribute("converterKey", (Object)fv.getConverterKey());
            SysAttViewerUtil.logger.debug("converterKey:" + fv.getConverterKey());
            final String fileFullName = attMain.getFdFileName();
            request.setAttribute("fileFullName", (Object)fileFullName);
            String fileName = "";
            if (fileFullName.length() > 12) {
                fileName = String.valueOf(fileFullName.substring(0, 12)) + "...";
            }
            else {
                fileName = fileFullName;
            }
            request.setAttribute("fileName", (Object)fileName);
            request.setAttribute("fileSize", (Object)convertFileSize(attMain.getFdSize()));
            if ("toHTML".equals(fv.getConverterKey().split("-")[0])) {
                String viewerStyle = "";
                String fileExtName = "";
                int htmlPageCount = 0;
                int picPageCount = 0;
                try {
                    final JSONObject viewerParamJson = JSONObject.fromObject((Object)viewerParam);
                    viewerStyle = viewerParamJson.getString("viewerStyle");
                    fileExtName = viewerParamJson.getString("fileExtName");
                    if (viewerParamJson.containsKey((Object)"htmlPageCount")) {
                        htmlPageCount = viewerParamJson.getInt("htmlPageCount");
                    }
                    if (viewerParamJson.containsKey((Object)"picPageCount")) {
                        picPageCount = viewerParamJson.getInt("picPageCount");
                    }
                    if (htmlPageCount == 0 && viewerParamJson.containsKey((Object)"totalPageCount")) {
                        htmlPageCount = viewerParamJson.getInt("totalPageCount");
                    }
                    if (picPageCount == 0 && viewerParamJson.containsKey((Object)"totalPageCount")) {
                        picPageCount = viewerParamJson.getInt("totalPageCount");
                    }
                }
                catch (final Exception ex) {
                    final String[] paramArray = viewerParam.split(",");
                    for (int i = 0; i < paramArray.length; ++i) {
                        final String[] param = paramArray[i].split(":");
                        if ("viewerStyle".equals(param[0])) {
                            viewerStyle = param[1];
                        }
                        if ("totalPageCount".equals(param[0])) {
                            htmlPageCount = Integer.valueOf(param[1]);
                            picPageCount = Integer.valueOf(param[1]);
                        }
                    }
                }
                if ("et".equals(fileExtName)) {
                    viewerStyle = String.valueOf(viewerStyle) + fileExtName;
                }
                SysAttViewerUtil.logger.debug("viewerStyle:" + viewerStyle);
                SysAttViewerUtil.logger.debug("htmlPageCount:" + htmlPageCount);
                SysAttViewerUtil.logger.debug("picPageCount:" + picPageCount);
                request.setAttribute("viewerStyle", (Object)viewerStyle);
                request.setAttribute("htmlPageCount", (Object)htmlPageCount);
                request.setAttribute("picPageCount", (Object)picPageCount);
                request.setAttribute("highFidelity", (Object)fv.getFdHighFidelity());
                final JSONObject waterMarkInDB = getWaterMarkConfigInDB(true);
                waterMarkInDB.accumulate("otherInfos", (Object)getWaterMarkInfos(waterMarkInDB, request));
                request.setAttribute("waterMarkConfig", (Object)waterMarkInDB.toString());
            }
        }
        return viewerPath;
    }
    
    public static String getIconClassByFileName(final String fileName) {
        if (StringUtil.isNull(fileName)) {
            return "icon_documents";
        }
        String fileExt = fileName.substring(fileName.lastIndexOf("."));
        if (StringUtil.isNotNull(fileExt)) {
            fileExt = fileExt.toLowerCase();
        }
        final String s;
        switch ((s = fileExt).hashCode()) {
            case 46033: {
                if (!s.equals(".7z")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_zip";
            }
            case 47521: {
                if (!s.equals(".gz")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_zip";
            }
            case 47849: {
                if (!s.equals(".rm")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_rmvb";
            }
            case 1470026: {
                if (!s.equals(".doc")) {
                    return "icon_" + fileExt.substring(1);
                }
                break;
            }
            case 1475827: {
                if (!s.equals(".jpg")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_jpg";
            }
            case 1481606: {
                if (!s.equals(".ppt")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_ppt";
            }
            case 1481699: {
                if (!s.equals(".pst")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_outlook";
            }
            case 1483061: {
                if (!s.equals(".rar")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_zip";
            }
            case 1484983: {
                if (!s.equals(".tar")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_zip";
            }
            case 1485698: {
                if (!s.equals(".txt")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_text";
            }
            case 1489169: {
                if (!s.equals(".xls")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_excel";
            }
            case 1490995: {
                if (!s.equals(".zip")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_zip";
            }
            case 45570926: {
                if (!s.equals(".docx")) {
                    return "icon_" + fileExt.substring(1);
                }
                break;
            }
            case 45750678: {
                if (!s.equals(".jpeg")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_jpg";
            }
            case 45929906: {
                if (!s.equals(".pptx")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_ppt";
            }
            case 45986645: {
                if (!s.equals(".rmvb")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_rmvb";
            }
            case 46164359: {
                if (!s.equals(".xlsx")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_excel";
            }
            case 1410107496: {
                if (!s.equals(".audio")) {
                    return "icon_" + fileExt.substring(1);
                }
                return "icon_aud";
            }
        }
        return "icon_word";
    }
    
    public static String getViewerPath(final SysAttMain attMain, final HttpServletRequest request) throws Exception {
        final List<SysFileViewerParam> convertedParamsList = getConvertedParams(attMain);
        final List<SysFileStoreUtil.FileConverter> fileConverters = SysFileStoreUtil.getFileConverters(getExtName(attMain.getFdFileName()), attMain.getFdModelName(), SysFileStoreUtil.isOldConvertSuccessUseHTML());
        return getViewerPath(attMain, convertedParamsList, fileConverters, request);
    }
    
    public static String convertFileSize(final Double size) {
        final DecimalFormat df = new DecimalFormat("#.00");
        String filesize = "";
        if (size < 1024.0) {
            filesize = String.valueOf(df.format(size)) + "B";
        }
        else if (size < 1048576.0) {
            filesize = String.valueOf(df.format(size / 1024.0)) + "KB";
        }
        else if (size < 1.073741824E9) {
            filesize = String.valueOf(df.format(size / 1048576.0)) + "MB";
        }
        else {
            filesize = String.valueOf(df.format(size / 1.073741824E9)) + "GB";
        }
        return filesize;
    }
    
    private static FileViewer getViewer(final List<SysFileViewerParam> convertedParamsList, final String viewerKey, final Map<String, FileViewer> allViewers, final List<SysFileStoreUtil.FileConverter> fileConverters, final String fdFileExtName) {
        FileViewer resultViewer = null;
        final SysFileStoreUtil.FileConverter[] convertersArray = new SysFileStoreUtil.FileConverter[fileConverters.size()];
        fileConverters.toArray(convertersArray);
        if (convertedParamsList != null && convertedParamsList.size() > 0) {
            if (StringUtil.isNotNull(viewerKey)) {
                if (allViewers.containsKey(viewerKey)) {
                    resultViewer = allViewers.get(viewerKey);
                    for (final SysFileViewerParam item : convertedParamsList) {
                        final String itemViewerKey = new String(item.getFdViewerKey());
                        if (viewerKey.toLowerCase().equals(itemViewerKey.toLowerCase())) {
                            resultViewer.setConverterKey(item.getFdConverterKey());
                            if (StringUtil.isNotNull(item.getFdParameterLong())) {
                                resultViewer.setViewerParam(item.getFdParameterLong());
                            }
                            else {
                                resultViewer.setViewerParam(item.getFdParameter());
                            }
                            resultViewer.setFdHighFidelity(getHighFidelity(item, convertersArray));
                            break;
                        }
                    }
                }
            }
            else if (fileConverters.size() > 0) {
                Collections.sort(fileConverters, new Comparator<SysFileStoreUtil.FileConverter>() {
                    @Override
                    public int compare(final SysFileStoreUtil.FileConverter o1, final SysFileStoreUtil.FileConverter o2) {
                        final int o1_len = o1.getModelName().length();
                        final int o2_len = o2.getModelName().length();
                        return (o1_len > o2_len) ? -1 : ((o1_len < o2_len) ? 1 : 0);
                    }
                });
                for (int i = 0; i < fileConverters.size(); ++i) {
                    final SysFileStoreUtil.FileConverter fileConverter = fileConverters.get(i);
                    for (final SysFileViewerParam itemParam : convertedParamsList) {
                        if (itemParam.getFdViewerKey().toLowerCase().contains("mobile")) {
                            continue;
                        }
                        final String itemViewerKey2 = new String(itemParam.getFdViewerKey());
                        final String converterKey = new String(itemParam.getFdConverterKey());
                        String filConvertKey = fileConverter.getConverterKey();
                        if ("toJPG".equals(filConvertKey)) {
                            filConvertKey = "toHTML";
                        }
                        final String extendName = fileConverter.getExtName();
                        final String convertType = fileConverter.getConverterType();
                        if ("aspose".equalsIgnoreCase(convertType) && ((("dwg".equalsIgnoreCase(extendName) || extendName.toLowerCase().contains("dwg")) && "dwg".equals(fdFileExtName)) || (("dxf".equalsIgnoreCase(extendName) || extendName.toLowerCase().contains("dxf")) && "dxf".equals(fdFileExtName)) || (("dwf".equalsIgnoreCase(extendName) || extendName.toLowerCase().contains("dwf")) && "dwf".equals(fdFileExtName)))) {
                            filConvertKey = "cadToImg";
                        }
                        if ((converterKey.split("-")[0].equals(filConvertKey) || isVideoToMp4(converterKey.split("-")[0], filConvertKey)) && allViewers.containsKey(itemViewerKey2)) {
                            resultViewer = allViewers.get(itemViewerKey2);
                            resultViewer.setConverterKey(itemParam.getFdConverterKey());
                            if (StringUtil.isNotNull(itemParam.getFdParameterLong())) {
                                resultViewer.setViewerParam(itemParam.getFdParameterLong());
                            }
                            else {
                                resultViewer.setViewerParam(itemParam.getFdParameter());
                            }
                            resultViewer.setFdHighFidelity(getHighFidelity(itemParam, fileConverter));
                            break;
                        }
                    }
                }
            }
        }
        return resultViewer;
    }
    
    private static boolean isVideoToMp4(final String string, final String converterKey) {
        return "videoToMp4".equals(string) && "videoToFlv".equals(converterKey);
    }
    
    private static String getHighFidelity(final SysFileViewerParam item, final SysFileStoreUtil.FileConverter... fileConverters) {
        String resultHighFidelity = "";
        if ("toHTML".equals(item.getFdConverterKey().split("-")[0])) {
            JSONObject jsonParam = null;
            if (StringUtil.isNotNull(item.getFdParameterLong())) {
                jsonParam = JSONObject.fromObject((Object)item.getFdParameterLong());
            }
            else if (StringUtil.isNotNull(item.getFdParameter())) {
                jsonParam = JSONObject.fromObject((Object)item.getFdParameter());
            }
            if (jsonParam != null) {
                if (jsonParam.containsKey((Object)"fileExtName")) {
                    jsonParam.getString("fileExtName");
                }
                String highFidelity_html = "0";
                if (jsonParam.containsKey((Object)"highFidelity_html")) {
                    highFidelity_html = "1";
                }
                String highFidelity_pic = "0";
                if (jsonParam.containsKey((Object)"highFidelity_pic")) {
                    highFidelity_pic = "1";
                }
                if ("1".equals(highFidelity_html)) {
                    resultHighFidelity = String.valueOf(resultHighFidelity) + "html";
                }
                if ("1".equals(highFidelity_pic)) {
                    resultHighFidelity = String.valueOf(resultHighFidelity) + "pic";
                }
            }
        }
        return resultHighFidelity;
    }
    
    public static List<SysFileViewerParam> getConvertedParams(final SysAttMain attMain) throws Exception {
        final HQLInfo hqlInfo = new HQLInfo();
        String whereBlock = "";
        if (StringUtil.isNotNull(attMain.getFdFileId())) {
            whereBlock = String.valueOf(whereBlock) + " fdFileId=:fdFileId ";
            hqlInfo.setParameter("fdFileId", (Object)attMain.getFdFileId());
        }
        else {
            whereBlock = String.valueOf(whereBlock) + " fdAttMainId=:fdAttMainId ";
            hqlInfo.setParameter("fdAttMainId", (Object)attMain.getFdId());
        }
        hqlInfo.setWhereBlock(whereBlock);
        hqlInfo.setGetCount(false);
        return SysAttViewerUtil.convertDataService.getViewerParamService().findList(hqlInfo);
    }
    
    public static String checkConvertingByAttId(final SysAttMain attMain) throws Exception {
        String _rtnStrin = "001";
        final HQLInfo hqlInfo = new HQLInfo();
        String whereBlock = "";
        if (StringUtil.isNotNull(attMain.getFdFileId())) {
            whereBlock = String.valueOf(whereBlock) + " fdFileId=:fdFileId ";
            hqlInfo.setParameter("fdFileId", (Object)attMain.getFdFileId());
        }
        else {
            whereBlock = String.valueOf(whereBlock) + " fdAttMainId=:fdAttMainId ";
            hqlInfo.setParameter("fdAttMainId", (Object)attMain.getFdId());
        }
        whereBlock = String.valueOf(whereBlock) + " and fdConverterKey in ('cadToImg','toHTML','videoToMp4','toPDF') ";
        hqlInfo.setWhereBlock(whereBlock);
        hqlInfo.setGetCount(false);
        final ISysFileConvertQueueService queueService = (ISysFileConvertQueueService)SpringBeanUtil.getBean("sysFileConvertQueueService");
        final SysFileConvertQueue convert = (SysFileConvertQueue)queueService.findFirstOne(hqlInfo);
        if (convert == null) {
            addQueue(attMain);
        }
        else {
            _rtnStrin = String.valueOf(convert.getFdConvertStatus());
        }
        return _rtnStrin;
    }
    
    public static String getConvertFilePath(final SysAttMain attMain, final String convertFileName) throws Exception {
        if (convertFileName.contains("/") || convertFileName.contains("\\") || convertFileName.contains("..")) {
            return null;
        }
        final String attFilePath = getAttFilePath((SysAttBase)attMain);
        String convertFile = "";
        convertFile = String.valueOf(attFilePath) + "_convert" + "/" + convertFileName;
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile file = sysAttUploadService.getFileById(attMain.getFdFileId());
        final ISysFileLocationProxyService proxyService = SysFileLocationUtil.getProxyService(file.getFdAttLocation());
        final String pathPrefix = (file.getFdCata() == null) ? null : file.getFdCata().getFdPath();
        if (proxyService.doesFileExist(convertFile, pathPrefix)) {
            return convertFile;
        }
        return attFilePath;
    }
    
    public static boolean checkZipFileIsConvertSuccess(final SysAttMain attMain) throws Exception {
        final String attFilePath = getAttFilePath((SysAttBase)attMain);
        String _conStr = "_uncompress";
        final String location = ResourceUtil.getKmssConfigString("sys.att.location");
        if (!"server".equals(location)) {
            _conStr = String.valueOf(_conStr) + "/";
        }
        final String convertFile = String.valueOf(attFilePath) + _conStr;
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile file = sysAttUploadService.getFileById(attMain.getFdFileId());
        final ISysFileLocationProxyService proxyService = SysFileLocationUtil.getProxyService(file.getFdAttLocation());
        final String pathPrefix = (file.getFdCata() == null) ? null : file.getFdCata().getFdPath();
        final boolean _rtnStatus = proxyService.doesFileExist(convertFile, pathPrefix);
        SysAttViewerUtil.logger.debug("查询附件 : 路径={}，是否存在={}", convertFile, _rtnStatus);
        return _rtnStatus;
    }
    
    public static InputStream getConvertFileInputStream(final SysAttMain attMain, final String convertFileName) throws Exception {
        final String convertFile = getConvertFilePath(attMain, convertFileName);
        if (StringUtil.isNull(convertFile)) {
            return null;
        }
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile attFile = sysAttUploadService.getFileById(attMain.getFdFileId());
        final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation());
        final String pathPrefix = (attFile.getFdCata() == null) ? null : attFile.getFdCata().getFdPath();
        return sysFileLocationService.readFile(convertFile, pathPrefix);
    }
    
    public static String getFileThumbPath(final SysAttMain attMain, final List<SysFileViewerParam> convertedParamsList, final List<SysFileStoreUtil.FileConverter> fileConverters, final HttpServletRequest request) throws Exception {
        String thumbNailFile = "";
        final String attFilePath = getAttFilePath((SysAttBase)attMain);
        final String viewerPath = getViewerPath(attMain, convertedParamsList, fileConverters, request);
        if (StringUtil.isNull(viewerPath)) {
            return null;
        }
        thumbNailFile = String.valueOf(attFilePath) + "_convert/" + request.getAttribute("converterKey") + "_thumbnail";
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile file = sysAttUploadService.getFileById(attMain.getFdFileId());
        final String pathPrefix = (file.getFdCata() == null) ? null : file.getFdCata().getFdPath();
        if (SysFileLocationUtil.getProxyService(file.getFdAttLocation()).doesFileExist(thumbNailFile, pathPrefix)) {
            return thumbNailFile;
        }
        if (SysAttUtil.isOfficeType(FilenameUtils.getExtension(attMain.getFdFileName()))) {
            return null;
        }
        return attFilePath;
    }
    
    public static InputStream getFileThumbInputStream(final SysAttMain attMain, final List<SysFileViewerParam> convertedParamsList, final List<SysFileStoreUtil.FileConverter> fileConverters, final HttpServletRequest request) throws Exception {
        final String path = getFileThumbPath(attMain, convertedParamsList, fileConverters, request);
        if (StringUtil.isNull(path)) {
            return new FileInputStream(String.valueOf(PluginConfigLocationsUtil.getWebContentPath()) + "/sys/attachment/viewer/resource/common/images/unConverted.png");
        }
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile attFile = sysAttUploadService.getFileById(attMain.getFdFileId());
        final String pathPrefix = (attFile.getFdCata() == null) ? null : attFile.getFdCata().getFdPath();
        return SysFileLocationUtil.getProxyService(attFile.getFdAttLocation()).readFile(path, pathPrefix);
    }
    
    public static String getAttFilePath(final SysAttBase att) throws Exception {
        return SysAttViewerUtil.convertDataService.getFilePath(att.getFdFileId(), att.getFdId());
    }
    
    public static String getAttFileFullPath(final SysAttBase att) throws Exception {
        return SysAttViewerUtil.convertDataService.getFilePath(att.getFdFileId(), att.getFdId(), Boolean.valueOf(true));
    }
    
    public static String getPicThumbPath(final SysAttBase sysAttBase, final String picThumb) throws Exception {
        String fileFullPath = "";
        final String attFileFullPath = fileFullPath = getAttFilePath(sysAttBase);
        if ("big".equals(picThumb)) {
            fileFullPath = String.valueOf(fileFullPath) + "_convert/image2thumbnail_" + SysFileStoreUtil.getBigImageWidth();
        }
        if ("small".equals(picThumb)) {
            fileFullPath = String.valueOf(fileFullPath) + "_convert/image2thumbnail_" + SysFileStoreUtil.getSmallImageWidth();
        }
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile file = sysAttUploadService.getFileById(sysAttBase.getFdFileId());
        final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService(file.getFdAttLocation());
        final String pathPrefix = (file.getFdCata() == null) ? null : file.getFdCata().getFdPath();
        if (StringUtil.isNull(picThumb) || "original".equals(picThumb) || !sysFileLocationService.doesFileExist(fileFullPath, pathPrefix)) {
            return attFileFullPath;
        }
        return fileFullPath;
    }
    
    public static InputStream getPicThumbStream(final SysAttMain attMain, final HttpServletRequest request) throws Exception {
        final String picThumb = request.getParameter("picthumb");
        final String path = getPicThumbPath((SysAttBase)attMain, picThumb);
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile attFile = sysAttUploadService.getFileById(attMain.getFdFileId());
        final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation());
        final String pathPrefix = (attFile.getFdCata() == null) ? null : attFile.getFdCata().getFdPath();
        return sysFileLocationService.readFile(path, pathPrefix);
    }
    
    public static InputStream getFileInputStream(final SysAttMain attMain) throws Exception {
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile attFile = sysAttUploadService.getFileById(attMain.getFdFileId());
        final String pathPrefix = (attFile.getFdCata() == null) ? null : attFile.getFdCata().getFdPath();
        return SysFileLocationUtil.getProxyService(attFile.getFdAttLocation()).readFile(getAttFilePath((SysAttBase)attMain), pathPrefix);
    }
    
    public static boolean isLowerThanIE8(final HttpServletRequest request) {
        final String userAgent = request.getHeader("User-Agent").toLowerCase();
        return userAgent.indexOf("msie") > 0 && getIEVersion(userAgent) < 5;
    }
    
    private static int getIEVersion(final String userAgent) {
        final String trident = userAgent.substring(userAgent.indexOf("trident") + 8, userAgent.indexOf("trident") + 9);
        try {
            return Integer.valueOf(StringUtil.isNotNull(trident) ? trident : "0");
        }
        catch (final Exception ex) {
            return 0;
        }
    }
    
    public static boolean isConverted(final SysAttMain attMain) throws Exception {
        final List<SysFileViewerParam> convertedParams = getConvertedParams(attMain);
        final List<SysFileStoreUtil.FileConverter> fileConverters = SysFileStoreUtil.getFileConverters(getExtName(attMain.getFdFileName()), attMain.getFdModelName(), SysFileStoreUtil.isOldConvertSuccessUseHTML());
        return convertedParams != null && convertedParams.size() > 0 && fileConverters != null && fileConverters.size() > 0;
    }
    
    public static void addQueue(final SysAttMain sysAttMain) throws Exception {
        final ISysFileConvertQueueService queueService = (ISysFileConvertQueueService)SpringBeanUtil.getBean("sysFileConvertQueueService");
        queueService.addQueue(sysAttMain.getFdFileId(), sysAttMain.getFdFileName(), sysAttMain.getFdModelName(), sysAttMain.getFdModelId(), (String)null, sysAttMain.getFdId());
    }
    
    private static String findAppConfigValue(final String whereBlock, final String hintValue) throws Exception {
        final List<String> valueList = SysAttViewerUtil.convertDataService.getAppConfigService().findValue("fdValue", whereBlock, "");
        if (valueList == null || valueList.size() == 0) {
            return hintValue;
        }
        return StringUtil.isNull((String)valueList.get(0)) ? hintValue : valueList.get(0);
    }
    
    private static String getWaterMarkGlobalValue(final String fdKey, final String defaultValue) {
        try {
            return findAppConfigValue("fdKey='" + fdKey + "'", defaultValue);
        }
        catch (final Exception e) {
            e.printStackTrace();
            return "";
        }
    }
    
    private static void setWaterMarkGlobalValue(final String fdKey, final String fdValue) throws Exception {
        final SysAppConfig appConfig = new SysAppConfig();
        appConfig.setFdKey(fdKey);
        appConfig.setFdValue(fdValue);
        final HQLInfo info = new HQLInfo();
        info.setSelectBlock("fdId");
        info.setWhereBlock("fdKey=:fdKey");
        info.setParameter("fdKey", (Object)fdKey);
        final List<String> fdIdList = SysAttViewerUtil.convertDataService.getAppConfigService().findValue(info);
        if (fdIdList == null || fdIdList.size() == 0) {
            SysAttViewerUtil.convertDataService.getAppConfigService().add((IBaseModel)appConfig);
        }
        else {
            appConfig.setFdId((String)fdIdList.get(0));
            SysAttViewerUtil.convertDataService.getAppConfigService().update((IBaseModel)appConfig);
        }
    }
    
    public static InputStream getWaterMarkPNG(final JSONObject waterMarkConfig) throws Exception {
        InputStream resultMarkPNG = null;
        if (waterMarkConfig.has("showWaterMark")) {
            final String showWaterMark = waterMarkConfig.getString("showWaterMark");
            if ("true".equals(showWaterMark)) {
                final String waterMarkType = waterMarkConfig.getString("markType");
                "word".equals(waterMarkType);
                if ("pic".equals(waterMarkType)) {
                    final String markPicFileName = waterMarkConfig.getString("markPicFileName");
                    resultMarkPNG = getPicFileInputStream(markPicFileName);
                }
            }
            return resultMarkPNG;
        }
        return getWaterMarkPNG(getWaterMarkConfigInDB(true));
    }
    
    private static InputStream getPicFileInputStream(final String markPicFileName) throws Exception {
        final String picFile = String.valueOf(getWaterMarkPicFileDir()) + "/" + markPicFileName;
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile attFile = sysAttUploadService.getFileByPath(picFile);
        final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation());
        final String pathPrefix = (attFile.getFdCata() == null) ? null : attFile.getFdCata().getFdPath();
        if (sysFileLocationService.doesFileExist(picFile, pathPrefix)) {
            return sysFileLocationService.readFile(picFile, pathPrefix);
        }
        return null;
    }
    
    private static InputStream getWordMarkPNG(final String markWord, final String fontFamily, final String fontColor, final String fontSize, final String rotateType, final String rotateAngel) {
        int angel = 0;
        if ("declining".equals(rotateType)) {
            angel = Integer.parseInt(rotateAngel);
        }
        final Font font = new Font(fontFamily, 0, Integer.parseInt(fontSize));
        final FontMetrics fm = FontDesignMetrics.getMetrics(font);
        final int strWidth = fm.stringWidth(markWord);
        final int strHeight = fm.getHeight();
        int imgWidth = strWidth;
        int imgHeight = strHeight;
        if ("declining".equals(rotateType)) {
            final Rectangle oldTangle = new Rectangle(new Dimension(strWidth, strHeight));
            final Rectangle newTangle = calcRotatedSize(oldTangle, angel);
            imgWidth = newTangle.width;
            imgHeight = newTangle.height;
        }
        final int ascent = fm.getAscent();
        final int descent = fm.getDescent();
        final int y = (imgHeight - (ascent + descent)) / 2 + ascent;
        final int x = (imgWidth - strWidth) / 2;
        BufferedImage srcImg = new BufferedImage(imgWidth, imgHeight, 1);
        Graphics2D graphics = srcImg.createGraphics();
        srcImg = graphics.getDeviceConfiguration().createCompatibleImage(imgWidth, imgHeight, 3);
        graphics.dispose();
        graphics = srcImg.createGraphics();
        graphics.setStroke(new BasicStroke(1.0f));
        graphics.setColor(stringToColor(fontColor));
        graphics.setFont(font);
        if ("declining".equals(rotateType)) {
            graphics.translate((imgWidth - strWidth) / 2, (imgHeight - strHeight) / 2);
            graphics.rotate(Math.toRadians(angel), strWidth / 2, strHeight / 2);
            graphics.drawString(markWord, 0, y / 2);
        }
        else {
            graphics.drawString(markWord, x, y);
        }
        final ByteArrayOutputStream bos = new ByteArrayOutputStream();
        graphics.dispose();
        try {
            ImageIO.write(srcImg, "png", bos);
        }
        catch (final Throwable e) {
            SysAttViewerUtil.logger.info("error", e);
        }
        return new ByteArrayInputStream(bos.toByteArray());
    }
    
    private static Rectangle calcRotatedSize(final Rectangle src, int angel) {
        if (angel >= 90) {
            if (angel / 90 % 2 == 1) {
                final int temp = src.height;
                src.height = src.width;
                src.width = temp;
            }
            angel %= 90;
        }
        final double r = Math.sqrt(src.height * src.height + src.width * src.width) / 2.0;
        final double len = 2.0 * Math.sin(Math.toRadians(angel) / 2.0) * r;
        final double angel_alpha = (3.141592653589793 - Math.toRadians(angel)) / 2.0;
        final double angel_dalta_width = Math.atan(src.height / (double)src.width);
        final double angel_dalta_height = Math.atan(src.width / (double)src.height);
        final int len_dalta_width = (int)(len * Math.cos(3.141592653589793 - angel_alpha - angel_dalta_width));
        final int len_dalta_height = (int)(len * Math.cos(3.141592653589793 - angel_alpha - angel_dalta_height));
        final int des_width = src.width + len_dalta_width * 2;
        final int des_height = src.height + len_dalta_height * 2;
        return new Rectangle(new Dimension(des_width, des_height));
    }
    
    public static JSONObject getWaterMarkConfigInDB(final Boolean check) {
        final JSONObject resultConfig = new JSONObject();
        String enable = getWaterMarkGlobalValue("watermark.enable", "false");
        final HttpServletRequest request = Plugin.currentRequest();
        if (!"true".equals(request.getAttribute("isConfig"))) {
            final String enablePC = getWaterMarkGlobalValue("watermark.enablePC", "true");
            final String enableMobile = getWaterMarkGlobalValue("watermark.enableMobile", "true");
            final boolean isMobile = MobileUtil.isMobile(request);
            if ("true".equals(enable) && !isMobile && !"true".equals(enablePC)) {
                enable = "false";
            }
            else if ("true".equals(enable) && isMobile && !"true".equals(enableMobile)) {
                enable = "false";
            }
        }
        final boolean isAvailable = UserUtil.getKMSSUser().getUserAuthInfo().getAuthRoleAliases().contains("ROLE_SYSATTACHMENT_REMOVE_WATERMARK");
        if (check && isAvailable) {
            enable = "false";
        }
        resultConfig.accumulate("showWaterMark", (Object)enable);
        resultConfig.accumulate("enablePC", (Object)getWaterMarkGlobalValue("watermark.enablePC", "true"));
        resultConfig.accumulate("enableMobile", (Object)getWaterMarkGlobalValue("watermark.enableMobile", "true"));
        resultConfig.accumulate("markOpacity", (Object)getWaterMarkGlobalValue("watermark.opacity", "0.5"));
        resultConfig.accumulate("markType", (Object)getWaterMarkGlobalValue("watermark.type", "word"));
        resultConfig.accumulate("markWordVar", (Object)getWaterMarkGlobalValue("watermark.word.var", ""));
        resultConfig.accumulate("markWordFontFamily", (Object)getWaterMarkGlobalValue("watermark.word.fontfamily", ""));
        resultConfig.accumulate("markWordFontColor", (Object)getWaterMarkGlobalValue("watermark.word.fontcolor", "#cccccc"));
        resultConfig.accumulate("markWordFontSize", (Object)getWaterMarkGlobalValue("watermark.word.fontsize", "36"));
        resultConfig.accumulate("markRowSpace", (Object)getWaterMarkGlobalValue("watermark.rowspace", "50"));
        resultConfig.accumulate("markColSpace", (Object)getWaterMarkGlobalValue("watermark.colspace", "30"));
        resultConfig.accumulate("markRotateType", (Object)getWaterMarkGlobalValue("watermark.rotatetype", "declining"));
        resultConfig.accumulate("markRotateAngel", (Object)getWaterMarkGlobalValue("watermark.rotateangel", "330"));
        resultConfig.accumulate("markPicFileName", (Object)getWaterMarkGlobalValue("watermark.pic.filename", ""));
        return resultConfig;
    }
    
    public static JSONObject getWaterMarkConfigInDBBySuwell(final Boolean check, final Boolean isMobile) {
        final JSONObject resultConfig = new JSONObject();
        String enable = getWaterMarkGlobalValue("watermark.enable", "false");
        final HttpServletRequest request = Plugin.currentRequest();
        if (!"true".equals(request.getAttribute("isConfig"))) {
            final String enablePC = getWaterMarkGlobalValue("watermark.enablePC", "true");
            final String enableMobile = getWaterMarkGlobalValue("watermark.enableMobile", "true");
            if ("true".equals(enable) && !isMobile && !"true".equals(enablePC)) {
                enable = "false";
            }
            else if ("true".equals(enable) && isMobile && !"true".equals(enableMobile)) {
                enable = "false";
            }
        }
        final boolean isAvailable = UserUtil.getKMSSUser().getUserAuthInfo().getAuthRoleAliases().contains("ROLE_SYSATTACHMENT_REMOVE_WATERMARK");
        if (check && isAvailable) {
            enable = "false";
        }
        resultConfig.accumulate("showWaterMark", (Object)enable);
        resultConfig.accumulate("enablePC", (Object)getWaterMarkGlobalValue("watermark.enablePC", "true"));
        resultConfig.accumulate("enableMobile", (Object)getWaterMarkGlobalValue("watermark.enableMobile", "true"));
        resultConfig.accumulate("markOpacity", (Object)getWaterMarkGlobalValue("watermark.opacity", "0.5"));
        resultConfig.accumulate("markType", (Object)getWaterMarkGlobalValue("watermark.type", "word"));
        resultConfig.accumulate("markWordVar", (Object)getWaterMarkGlobalValue("watermark.word.var", ""));
        resultConfig.accumulate("markWordFontFamily", (Object)getWaterMarkGlobalValue("watermark.word.fontfamily", ""));
        resultConfig.accumulate("markWordFontColor", (Object)getWaterMarkGlobalValue("watermark.word.fontcolor", "#cccccc"));
        resultConfig.accumulate("markWordFontSize", (Object)getWaterMarkGlobalValue("watermark.word.fontsize", "36"));
        resultConfig.accumulate("markRowSpace", (Object)getWaterMarkGlobalValue("watermark.rowspace", "50"));
        resultConfig.accumulate("markColSpace", (Object)getWaterMarkGlobalValue("watermark.colspace", "30"));
        resultConfig.accumulate("markRotateType", (Object)getWaterMarkGlobalValue("watermark.rotatetype", "declining"));
        resultConfig.accumulate("markRotateAngel", (Object)getWaterMarkGlobalValue("watermark.rotateangel", "330"));
        resultConfig.accumulate("markPicFileName", (Object)getWaterMarkGlobalValue("watermark.pic.filename", ""));
        return resultConfig;
    }
    
    public static JSONObject getWaterMarkConfigInRequest(final HttpServletRequest request, final String requestType) {
        final JSONObject resultConfig = new JSONObject();
        final String waterMarkEnable = request.getParameter("showWaterMark");
        if (StringUtil.isNotNull(waterMarkEnable) && "true".equals(waterMarkEnable)) {
            resultConfig.accumulate("showWaterMark", (Object)waterMarkEnable);
            final String markType = request.getParameter("markType");
            resultConfig.accumulate("markType", (Object)markType);
            resultConfig.accumulate("markWordVar", (Object)request.getParameter("markWordVar"));
            resultConfig.accumulate("markWordFontFamily", (Object)request.getParameter("markWordFontFamily"));
            resultConfig.accumulate("markWordFontColor", (Object)request.getParameter("markWordFontColor"));
            resultConfig.accumulate("markWordFontSize", (Object)request.getParameter("markWordFontSize"));
            resultConfig.accumulate("markPicFileName", (Object)request.getParameter("markPicFileName"));
            resultConfig.accumulate("markOpacity", (Object)request.getParameter("markOpacity"));
            resultConfig.accumulate("markRowSpace", (Object)request.getParameter("markRowSpace"));
            resultConfig.accumulate("markColSpace", (Object)request.getParameter("markColSpace"));
            final String rotateType = request.getParameter("markRotateType");
            resultConfig.accumulate("markRotateType", (Object)rotateType);
            resultConfig.accumulate("markRotateAngel", (Object)request.getParameter("markRotateAngel"));
        }
        else if (StringUtil.isNotNull(waterMarkEnable)) {
            resultConfig.accumulate("showWaterMark", (Object)"false");
        }
        return resultConfig;
    }
    
    private static Color stringToColor(final String str) {
        final int i = Integer.parseInt(str.substring(1), 16);
        return new Color(i);
    }
    
    public static void saveWaterMarkConfig(final SysAttWaterMarkForm waterMarkForm) throws Exception {
        String showWaterMark = waterMarkForm.getShowWaterMark();
        if (StringUtil.isNotNull(showWaterMark) && ("true".equals(showWaterMark) || "on".equals(showWaterMark))) {
            showWaterMark = "true";
        }
        else {
            showWaterMark = "false";
        }
        String enablePC = waterMarkForm.getEnablePC();
        String enableMobile = waterMarkForm.getEnableMobile();
        if (StringUtil.isNull(enablePC)) {
            enablePC = "false";
        }
        if (StringUtil.isNull(enableMobile)) {
            enableMobile = "false";
        }
        IUserUpdateDetailOper detailOper = null;
        if (UserOperHelper.allowLogOper("saveWaterMark", (String)null)) {
            UserOperHelper.setModelNameAndModelDesc((String)null, ResourceUtil.getString("sys-attachment:attachment.watermark.config"));
            detailOper = UserOperContentHelper.putUpdate(SysAppConfig.class.getName(), (String)null, (String)null).createOper4Detail("dataMap");
            detailOper.putUpdate("WaterMarkConfig", "").putSimple("watermark.enable", (Object)"", (Object)showWaterMark).putSimple("watermark.enablePC", (Object)"", (Object)enablePC).putSimple("watermark.enableMobile", (Object)"", (Object)enableMobile).putSimple("watermark.opacity", (Object)"", (Object)waterMarkForm.getMarkOpacity()).putSimple("watermark.type", (Object)"", (Object)waterMarkForm.getMarkType()).putSimple("watermark.rotatetype", (Object)"", (Object)waterMarkForm.getMarkRotateType()).putSimple("watermark.rowspace", (Object)"", (Object)waterMarkForm.getMarkRowSpace()).putSimple("watermark.colspace", (Object)"", (Object)waterMarkForm.getMarkColSpace()).putSimple("watermark.rotateangel", (Object)"", (Object)waterMarkForm.getMarkRotateAngel()).putSimple("watermark.word.var", (Object)"", (Object)waterMarkForm.getMarkWordVar()).putSimple("watermark.word.fontfamily", (Object)"", (Object)waterMarkForm.getMarkWordFontFamily()).putSimple("watermark.word.fontcolor", (Object)"", (Object)waterMarkForm.getMarkWordFontColor()).putSimple("watermark.word.fontsize", (Object)"", (Object)waterMarkForm.getMarkWordFontSize()).putSimple("watermark.pic.filename", (Object)"", (Object)waterMarkForm.getMarkPicFileName());
        }
        setWaterMarkGlobalValue("watermark.enable", showWaterMark);
        setWaterMarkGlobalValue("watermark.enablePC", enablePC);
        setWaterMarkGlobalValue("watermark.enableMobile", enableMobile);
        if ("true".equals(showWaterMark)) {
            setWaterMarkGlobalValue("watermark.opacity", waterMarkForm.getMarkOpacity());
            final String markType = waterMarkForm.getMarkType();
            setWaterMarkGlobalValue("watermark.type", markType);
            final String rotateType = waterMarkForm.getMarkRotateType();
            setWaterMarkGlobalValue("watermark.rotatetype", rotateType);
            setWaterMarkGlobalValue("watermark.rowspace", waterMarkForm.getMarkRowSpace());
            setWaterMarkGlobalValue("watermark.colspace", waterMarkForm.getMarkColSpace());
            if ("declining".equals(rotateType)) {
                setWaterMarkGlobalValue("watermark.rotateangel", waterMarkForm.getMarkRotateAngel());
            }
            if ("word".equals(markType)) {
                setWaterMarkGlobalValue("watermark.word.var", waterMarkForm.getMarkWordVar());
                setWaterMarkGlobalValue("watermark.word.fontfamily", waterMarkForm.getMarkWordFontFamily());
                setWaterMarkGlobalValue("watermark.word.fontcolor", waterMarkForm.getMarkWordFontColor());
                setWaterMarkGlobalValue("watermark.word.fontsize", waterMarkForm.getMarkWordFontSize());
            }
            if ("pic".equals(markType)) {
                final FormFile markPicFile = waterMarkForm.getMarkPicFile();
                setWaterMarkGlobalValue("watermark.pic.filename", waterMarkForm.getMarkPicFileName());
                generateMarkPicFile(markPicFile);
            }
        }
    }
    
    public static boolean isPicAtt(final SysAttMain sysAttMain) {
        return sysAttMain.getFdContentType().toLowerCase().contains("image");
    }
    
    private static void generateMarkPicFile(final FormFile markPicFile) throws Exception {
        if (markPicFile == null || StringUtil.isNull(markPicFile.getFileName())) {
            return;
        }
        if (markPicFile.getFileName().contains("..\\") || markPicFile.getFileName().contains("../")) {
            throw new KmssRuntimeException((Throwable)new Exception("error file name: " + markPicFile.getFileName()));
        }
        final String diskMarkPicFile = String.valueOf(getWaterMarkPicFileDir()) + "/" + markPicFile.getFileName();
        new ByteArrayOutputStream();
        SysFileLocationUtil.getProxyService().writeFile(markPicFile.getInputStream(), diskMarkPicFile);
    }
    
    private static String getWaterMarkPicFileDir() {
        return "/watermark";
    }
    
    public static String getMediaFilePath(final SysAttMain attMain) throws Exception {
        final List<SysFileViewerParam> params = getConvertedParams(attMain);
        String fileFullPath = getAttFilePath((SysAttBase)attMain);
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        if (params.size() > 0) {
            final String ck = params.get(0).getFdConverterKey();
            if (StringUtil.isNotNull(ck)) {
                final String attFileFullPath = String.valueOf(fileFullPath) + "_convert/" + ck + "_flv";
                final SysAttFile file = sysAttUploadService.getFileById(attMain.getFdFileId());
                final String pathPrefix = (file.getFdCata() == null) ? null : file.getFdCata().getFdPath();
                final boolean exists = SysFileLocationUtil.getProxyService(file.getFdAttLocation()).doesFileExist(attFileFullPath, pathPrefix);
                if (exists) {
                    fileFullPath = attFileFullPath;
                }
            }
        }
        return fileFullPath;
    }
    
    public static InputStream getMediaFileInputStream(final SysAttMain attMain) throws Exception {
        final String fileFullPath = getMediaFilePath(attMain);
        final ISysAttUploadService sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        final SysAttFile attFile = sysAttUploadService.getFileById(attMain.getFdFileId());
        final String pathPrefix = (attFile.getFdCata() == null) ? null : attFile.getFdCata().getFdPath();
        return SysFileLocationUtil.getProxyService(attFile.getFdAttLocation()).readFile(fileFullPath, pathPrefix);
    }
    
    public static JSONObject getWaterMarkInfos(final JSONObject waterMarkConfig, final HttpServletRequest request) {
        final JSONObject markInfos = new JSONObject();
        final String markType = waterMarkConfig.getString("markType");
        int markWidth = 0;
        int markHeight = 0;
        if ("word".equals(markType)) {
            final String fontFamily = waterMarkConfig.getString("markWordFontFamily");
            final Integer fontSize = Integer.parseInt(waterMarkConfig.getString("markWordFontSize"));
            String markWord = "";
            markWord = getVarMarkWord(waterMarkConfig.getString("markWordVar"), request);
            if (StringUtil.isNull(markWord)) {
                markWord = UserUtil.getUser().getFdName();
            }
            final Font font = new Font(fontFamily, 1, fontSize);
            final FontMetrics fm = FontDesignMetrics.getMetrics(font);
            markWidth = fm.stringWidth(markWord);
            markHeight = fm.getHeight();
            markInfos.accumulate("markWord", (Object)markWord);
        }
        else if ("pic".equals(markType)) {
            final String markPicFileName = waterMarkConfig.getString("markPicFileName");
            ImageInputStream imageStream = null;
            try {
                imageStream = ImageIO.createImageInputStream(getPicFileInputStream(markPicFileName));
                final Iterator<ImageReader> iter = ImageIO.getImageReaders(imageStream);
                if (iter.hasNext()) {
                    final ImageReader imageReader = iter.next();
                    imageReader.setInput(imageStream, true);
                    markWidth = imageReader.getWidth(0);
                    markHeight = imageReader.getHeight(0);
                }
                markInfos.accumulate("picUrl", (Object)(String.valueOf(request.getContextPath()) + "/sys/attachment/sys_att_watermark/sysAttWaterMark.do?method=getWaterMarkPNG"));
            }
            catch (final Exception e) {
                e.printStackTrace();
            }
        }
        markInfos.accumulate("markWidth", markWidth);
        markInfos.accumulate("markHeight", markHeight);
        return markInfos;
    }
    
    public static String getVarMarkWord(final String varMarkWord, final HttpServletRequest request) {
        return getVarMarkWord(varMarkWord, request, null);
    }
    
    public static String getVarMarkWord(final String varMarkWord, final HttpServletRequest request, final com.alibaba.fastjson.JSONObject json) {
        final StringBuffer resultSB = new StringBuffer();
        SysOrgPerson curUser = null;
        if (json != null) {
            final String userId = json.getString("userId");
            if (StringUtil.isNotNull(userId)) {
                curUser = UserUtil.getUser(userId);
            }
        }
        else {
            curUser = UserUtil.getUser();
        }
        final String curUserDept = (curUser.getFdParent() == null) ? "" : curUser.getFdParent().getFdName();
        final String curUserName = curUser.getFdName();
        final String curUserLoginName = curUser.getFdLoginName();
        final String curUserPhoneNo = curUser.getFdMobileNo();
        final String curDate = DateUtil.convertDateToString(new Date(), DateUtil.PATTERN_DATE);
        final String curIp = (request == null) ? json.getString("curIp") : request.getRemoteAddr();
        final SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        final String curTime = df.format(new Date());
        if (StringUtil.isNotNull(varMarkWord)) {
            final String[] vars = varMarkWord.split("%");
            try {
                String[] array;
                for (int length2 = (array = vars).length, i = 0; i < length2; ++i) {
                    final String item = array[i];
                    if (item.contains("(") && item.contains(",") && item.contains(")")) {
                        final int oneIndex = item.indexOf("(");
                        final int twoIndex = item.indexOf(",");
                        final int threeIndex = item.indexOf(")");
                        final String func = item.substring(0, oneIndex);
                        final String field = item.substring(oneIndex + 1, twoIndex);
                        final String length = item.substring(twoIndex + 1, threeIndex);
                        int subLength = 0;
                        try {
                            subLength = Integer.parseInt(length);
                        }
                        catch (final Exception ex) {
                            subLength = 0;
                        }
                        if ("dept".equals(field.toLowerCase().trim())) {
                            if ("right".equals(func.toLowerCase().trim())) {
                                resultSB.append(subRight(curUserDept, subLength));
                            }
                            else if ("left".equals(func.toLowerCase().trim())) {
                                resultSB.append(subLeft(curUserDept, subLength));
                            }
                        }
                        else if ("name".equals(field.toLowerCase().trim())) {
                            if ("right".equals(func.toLowerCase().trim())) {
                                resultSB.append(subRight(curUserName, subLength));
                            }
                            else if ("left".equals(func.toLowerCase().trim())) {
                                resultSB.append(subLeft(curUserName, subLength));
                            }
                        }
                        else if ("loginname".equals(field.toLowerCase().trim())) {
                            if ("right".equals(func.toLowerCase().trim())) {
                                resultSB.append(subRight(curUserLoginName, subLength));
                            }
                            else if ("left".equals(func.toLowerCase().trim())) {
                                resultSB.append(subLeft(curUserLoginName, subLength));
                            }
                        }
                        else if ("phoneno".equals(field.toLowerCase().trim())) {
                            if ("right".equals(func.toLowerCase().trim())) {
                                resultSB.append(subRight(curUserPhoneNo, subLength));
                            }
                            else if ("left".equals(func.toLowerCase().trim())) {
                                resultSB.append(subLeft(curUserPhoneNo, subLength));
                            }
                        }
                        else if ("date".equals(field.toLowerCase().trim())) {
                            if ("right".equals(func.toLowerCase().trim())) {
                                resultSB.append(subRight(curDate, subLength));
                            }
                            else if ("left".equals(func.toLowerCase().trim())) {
                                resultSB.append(subLeft(curDate, subLength));
                            }
                        }
                        else if ("ip".equals(field.toLowerCase().trim())) {
                            if ("right".equals(func.toLowerCase().trim())) {
                                resultSB.append(subRight(curIp, subLength));
                            }
                            else if ("left".equals(func.toLowerCase().trim())) {
                                resultSB.append(subLeft(curIp, subLength));
                            }
                        }
                        else if ("time".equals(field.toLowerCase().trim())) {
                            if ("right".equals(func.toLowerCase().trim())) {
                                resultSB.append(subRight(curTime, subLength));
                            }
                            else if ("left".equals(func.toLowerCase().trim())) {
                                resultSB.append(subLeft(curTime, subLength));
                            }
                        }
                        else if ("right".equals(func.toLowerCase().trim())) {
                            resultSB.append(subRight(field, subLength));
                        }
                        else if ("left".equals(func.toLowerCase().trim())) {
                            resultSB.append(subLeft(field, subLength));
                        }
                    }
                    else if ("dept".equals(item.toLowerCase().trim())) {
                        resultSB.append(StringUtil.isNull(curUserDept) ? "" : curUserDept);
                    }
                    else if ("name".equals(item.toLowerCase().trim())) {
                        resultSB.append(StringUtil.isNull(curUserName) ? "" : curUserName);
                    }
                    else if ("loginname".equals(item.toLowerCase().trim())) {
                        resultSB.append(StringUtil.isNull(curUserLoginName) ? "" : curUserLoginName);
                    }
                    else if ("phoneno".equals(item.toLowerCase().trim())) {
                        resultSB.append(StringUtil.isNull(curUserPhoneNo) ? "" : curUserPhoneNo);
                    }
                    else if ("date".equals(item.toLowerCase().trim())) {
                        resultSB.append(curDate);
                    }
                    else if ("ip".equals(item.toLowerCase().trim())) {
                        resultSB.append(curIp);
                    }
                    else if ("time".equals(item.toLowerCase().trim())) {
                        resultSB.append(curTime);
                    }
                    else {
                        resultSB.append(item);
                    }
                }
            }
            catch (final Exception ex2) {
                return null;
            }
        }
        return resultSB.toString();
    }
    
    public static String formatUrl(final HttpServletRequest request, final String url) {
        if (url.startsWith("/")) {
            return String.valueOf(request.getContextPath()) + url;
        }
        return url;
    }
    
    private static String subRight(final String value, final int length) {
        if (StringUtil.isNull(value)) {
            return "";
        }
        if (length > value.length() || length <= 0) {
            return value;
        }
        final int index = value.length() - length;
        return value.substring(index);
    }
    
    private static String subLeft(final String value, final int length) {
        if (StringUtil.isNull(value)) {
            return "";
        }
        if (length > value.length() || length <= 0) {
            return value;
        }
        return value.substring(0, length);
    }
    
    public static Map<String, Boolean> getConvertedResult(final List<SysAttMain> sysAttMains) {
        final Map<String, Boolean> result = new HashMap<String, Boolean>();
        if (sysAttMains != null && sysAttMains.size() > 0) {
            final HQLInfo hqlInfo = new HQLInfo();
            String whereBlock = "";
            for (final SysAttMain attMain : sysAttMains) {
                if (StringUtil.isNotNull(attMain.getFdFileId())) {
                    whereBlock = String.valueOf(whereBlock) + "or fdFileId='" + attMain.getFdFileId() + "' ";
                    result.put(attMain.getFdFileId(), Boolean.FALSE);
                }
                else {
                    whereBlock = String.valueOf(whereBlock) + "or fdAttMainId='" + attMain.getFdId() + "' ";
                    result.put(attMain.getFdId(), Boolean.FALSE);
                }
            }
            if (StringUtil.isNotNull(whereBlock)) {
                whereBlock = whereBlock.substring(3);
            }
            hqlInfo.setWhereBlock(whereBlock);
            hqlInfo.setGetCount(false);
            try {
                final List<SysFileViewerParam> params = SysAttViewerUtil.convertDataService.getViewerParamService().findList(hqlInfo);
                for (final SysFileViewerParam param : params) {
                    if (StringUtil.isNotNull(param.getFdFileId())) {
                        result.put(param.getFdFileId(), Boolean.TRUE);
                    }
                    else {
                        result.put(param.getFdAttMainId(), Boolean.TRUE);
                    }
                }
            }
            catch (final Exception e) {
                SysAttViewerUtil.logger.error("getConvertedResult", e);
            }
        }
        return result;
    }
    
    public static String getPreView(final SysAttMain attMain, final boolean isMobile) throws Exception {
        final String pc = SysAttConfigUtil.getOnlineToolType();
        String result = "";
        final boolean attConvertEnable = SysFileStoreUtil.isAttConvertEnable();
        final Boolean isWindows = SysAttWpsCloudUtil.checkWpsPreviewIsWindows();
        final Boolean isLinux = SysAttWpsCloudUtil.checkWpsPreviewIsLinux();
        final String fileName = attMain.getFdFileName();
        final String s;
        switch (s = pc) {
            case "0": {
                if ("2".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                    if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && !attConvertEnable) {
                        result = "jg";
                        if (isMobile) {
                            result = "cloud";
                        }
                        if (isWindows && isMobile) {
                            result = "window";
                        }
                        if (isLinux && isMobile) {
                            result = "linux";
                        }
                    }
                    if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && attConvertEnable) {
                        result = "converting";
                        if (isMobile) {
                            result = "cloud";
                        }
                        if (isWindows && isMobile) {
                            result = "window";
                        }
                        if (isLinux && isMobile) {
                            result = "linux";
                        }
                    }
                    if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && !attConvertEnable) {
                        if (JgWebOffice.isOfficePDFJudge()) {
                            result = "iWebPDF";
                            if (isMobile) {
                                result = "cloud";
                            }
                            if (isWindows && isMobile) {
                                result = "window";
                            }
                            if (isWindows && isMobile && JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux && isMobile) {
                                result = "linux";
                            }
                        }
                        else {
                            result = "download";
                            if (isMobile) {
                                result = "cloud";
                            }
                            if (isWindows) {
                                result = "window";
                            }
                            if (JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux) {
                                result = "linux";
                            }
                        }
                    }
                    if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && attConvertEnable) {
                        if (JgWebOffice.isOfficePDFJudge()) {
                            result = "iWebPDF";
                            if (isMobile) {
                                result = "cloud";
                            }
                            if (isWindows && isMobile && JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isWindows && isMobile && JgWebOffice.isPDF(fileName)) {
                                result = "window";
                            }
                            if (isLinux && isMobile) {
                                result = "linux";
                            }
                        }
                        else {
                            result = "download";
                            if (isMobile) {
                                result = "cloud";
                            }
                            if (isWindows) {
                                result = "window";
                            }
                            if (JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux) {
                                result = "linux";
                            }
                        }
                    }
                }
                if ("1".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                    if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && !attConvertEnable) {
                        result = "jg";
                        if (isMobile) {
                            result = "download";
                        }
                        if (isWindows && isMobile) {
                            result = "download";
                        }
                        if (isLinux && isMobile) {
                            result = "download";
                        }
                    }
                    if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && attConvertEnable) {
                        result = "converting";
                        if (isMobile) {
                            result = "converting";
                        }
                        if (isWindows && isMobile) {
                            result = "download";
                        }
                        if (isLinux && isMobile) {
                            result = "download";
                        }
                    }
                    if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && !attConvertEnable) {
                        if (JgWebOffice.isOfficePDFJudge()) {
                            result = "iWebPDF";
                            if (isMobile) {
                                result = "download";
                            }
                            if (isWindows && isMobile) {
                                result = "window";
                            }
                            if (isWindows && isMobile && JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux && isMobile) {
                                result = "linux";
                            }
                        }
                        else {
                            result = "download";
                            if (isWindows) {
                                result = "window";
                            }
                            if (JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux) {
                                result = "linux";
                            }
                        }
                    }
                    if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && attConvertEnable) {
                        if (JgWebOffice.isOfficePDFJudge()) {
                            result = "iWebPDF";
                            if (isMobile) {
                                result = "download";
                            }
                            if (isWindows && isMobile) {
                                result = "window";
                            }
                            if (isWindows && isMobile && JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux && isMobile) {
                                result = "linux";
                            }
                        }
                        else {
                            result = "download";
                            if (isWindows) {
                                result = "window";
                            }
                            if (JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux) {
                                result = "linux";
                            }
                        }
                    }
                }
                if (!"3".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                    break;
                }
                if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && !attConvertEnable) {
                    result = "jg";
                    if (isMobile) {
                        result = "download";
                    }
                    if (isWindows && isMobile) {
                        result = "download";
                    }
                    if (isLinux && isMobile) {
                        result = "download";
                    }
                }
                if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && attConvertEnable) {
                    result = "converting";
                    if (isMobile) {
                        result = "converting";
                    }
                    if (isWindows && isMobile) {
                        result = "converting";
                    }
                    if (isLinux && isMobile) {
                        result = "converting";
                    }
                }
                if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && !attConvertEnable) {
                    if (JgWebOffice.isOfficePDFJudge()) {
                        result = "iWebPDF";
                        if (isMobile) {
                            result = "download";
                        }
                        if (isWindows && isMobile) {
                            result = "window";
                        }
                        if (isWindows && isMobile && JgWebOffice.isOFD(fileName)) {
                            result = "download";
                        }
                        if (isLinux && isMobile) {
                            result = "linux";
                        }
                    }
                    else {
                        result = "download";
                        if (isWindows) {
                            result = "window";
                        }
                        if (JgWebOffice.isOFD(fileName)) {
                            result = "download";
                        }
                        if (isLinux) {
                            result = "linux";
                        }
                    }
                }
                if ((!JgWebOffice.isPDF(fileName) && !JgWebOffice.isOFD(fileName)) || !attConvertEnable) {
                    break;
                }
                if (JgWebOffice.isOfficePDFJudge()) {
                    result = "iWebPDF";
                    if (isMobile) {
                        result = "download";
                    }
                    if (isWindows && isMobile) {
                        result = "window";
                    }
                    if (isWindows && isMobile && JgWebOffice.isOFD(fileName)) {
                        result = "download";
                    }
                    if (isLinux && isMobile) {
                        result = "linux";
                        break;
                    }
                    break;
                }
                else {
                    result = "download";
                    if (isWindows) {
                        result = "window";
                    }
                    if (JgWebOffice.isOFD(fileName)) {
                        result = "download";
                    }
                    if (isLinux) {
                        result = "linux";
                        break;
                    }
                    break;
                }
                break;
            }
            case "1": {
                if (!isMobile) {
                    if (isWindows) {
                        result = "window";
                    }
                    if (isLinux) {
                        result = "linux";
                        break;
                    }
                    break;
                }
                else {
                    if ("2".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                        if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && !attConvertEnable) {
                            result = "cloud";
                            if (isWindows && isMobile) {
                                result = "window";
                            }
                            if (isLinux && isMobile) {
                                result = "linux";
                            }
                        }
                        if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && attConvertEnable) {
                            result = "cloud";
                            if (isWindows && isMobile) {
                                result = "window";
                            }
                            if (isLinux && isMobile) {
                                result = "linux";
                            }
                        }
                        if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && !attConvertEnable) {
                            result = "cloud";
                            if (isWindows && isMobile) {
                                result = "window";
                            }
                            if (JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux) {
                                result = "linux";
                            }
                        }
                        if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && attConvertEnable) {
                            result = "cloud";
                            if (isWindows && isMobile) {
                                result = "window";
                            }
                            if (JgWebOffice.isOFD(fileName)) {
                                result = "download";
                            }
                            if (isLinux) {
                                result = "linux";
                            }
                        }
                    }
                    if (!"1".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                        break;
                    }
                    if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && !attConvertEnable) {
                        result = "cloud";
                        if (isWindows && isMobile) {
                            result = "window";
                        }
                        if (isLinux && isMobile) {
                            result = "linux";
                        }
                    }
                    if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && attConvertEnable) {
                        result = "cloud";
                        if (isWindows && isMobile) {
                            result = "window";
                        }
                        if (isLinux && isMobile) {
                            result = "linux";
                        }
                    }
                    if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && !attConvertEnable) {
                        result = "cloud";
                        if (isWindows && isMobile) {
                            result = "window";
                        }
                        if (JgWebOffice.isOFD(fileName)) {
                            result = "download";
                        }
                        if (isLinux) {
                            result = "linux";
                        }
                    }
                    if ((!JgWebOffice.isPDF(fileName) && !JgWebOffice.isOFD(fileName)) || !attConvertEnable) {
                        break;
                    }
                    result = "cloud";
                    if (isWindows && isMobile) {
                        result = "window";
                    }
                    if (JgWebOffice.isOFD(fileName)) {
                        result = "download";
                    }
                    if (isLinux) {
                        result = "linux";
                        break;
                    }
                    break;
                }
                break;
            }
            case "3": {
                if ("2".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                    if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && !attConvertEnable) {
                        result = "oaassist";
                        if (isMobile) {
                            result = "cloud";
                        }
                        if (isWindows) {
                            result = "window";
                        }
                        if (isLinux) {
                            result = "linux";
                        }
                    }
                    if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && attConvertEnable) {
                        result = "oaassist";
                        if (isMobile) {
                            result = "cloud";
                        }
                        if (isWindows) {
                            result = "window";
                        }
                        if (isLinux) {
                            result = "linux";
                        }
                    }
                    if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && !attConvertEnable) {
                        result = "cloud";
                        if (isWindows && isMobile) {
                            result = "window";
                        }
                        if (JgWebOffice.isOFD(fileName)) {
                            result = "download";
                        }
                        if (isLinux) {
                            result = "linux";
                        }
                    }
                    if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && attConvertEnable) {
                        result = "cloud";
                        if (isWindows && isMobile) {
                            result = "window";
                        }
                        if (JgWebOffice.isOFD(fileName)) {
                            result = "download";
                        }
                        if (isLinux) {
                            result = "linux";
                        }
                    }
                }
                if (!"1".equals(SysAttConfigUtil.getMobileOnlineToolType())) {
                    break;
                }
                if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && !attConvertEnable) {
                    result = "oaassist";
                    if (isMobile) {
                        result = "download";
                    }
                    if (isWindows) {
                        result = "window";
                    }
                    if (isLinux) {
                        result = "linux";
                    }
                }
                if (SysAttUtil.isOfficeTypeByWps(FilenameUtils.getExtension(fileName)) && attConvertEnable) {
                    result = "oaassist";
                    if (isMobile) {
                        result = "download";
                    }
                    if (isWindows) {
                        result = "window";
                    }
                    if (isLinux) {
                        result = "linux";
                    }
                }
                if ((JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && !attConvertEnable) {
                    result = "download";
                    if (isWindows) {
                        result = "window";
                    }
                    if (JgWebOffice.isOFD(fileName)) {
                        result = "download";
                    }
                    if (isLinux) {
                        result = "linux";
                    }
                }
                if ((!JgWebOffice.isPDF(fileName) && !JgWebOffice.isOFD(fileName)) || !attConvertEnable) {
                    break;
                }
                result = "download";
                if (isWindows) {
                    result = "window";
                }
                if (JgWebOffice.isOFD(fileName)) {
                    result = "download";
                }
                if (isLinux) {
                    result = "linux";
                    break;
                }
                break;
            }
            default:
                break;
        }
        if (!JgWebOffice.isJGPDF2018Enabled() && (JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName))) {
            result = "linux";
        }
        if ("converting".equals(result)) {
            final List<SysFileViewerParam> convertedParams = getConvertedParams(attMain);
            if (convertedParams == null || convertedParams.size() <= 0) {
                result = "linux";
            }
        }
        if ("0".equals(SysAttConfigUtil.getOnlineToolType()) && !JgWebOffice.isJGPDFEnabled() && !JgWebOffice.isJGPDF2018Enabled() && (JgWebOffice.isPDF(fileName) || JgWebOffice.isOFD(fileName)) && "1".equals(SysAttConfigUtil.isReadPdf())) {
            result = "download";
        }
        if (JgWebOffice.isOFD(fileName) && "6".equals(SysAttConfigUtil.getReadOLConfig())) {
            result = "";
        }
        SysAttViewerUtil.logger.info("预览方式：" + result);
        return result;
    }
    
    public static String getDownloadUrl(final SysAttMain sysAttMain) throws Exception {
        String urlPrefix = ResourceUtil.getKmssConfigString("kmss.urlPrefix");
        if (urlPrefix.endsWith("/")) {
            urlPrefix = urlPrefix.substring(0, urlPrefix.lastIndexOf("/"));
        }
        if (SysAttViewerUtil.logger.isDebugEnabled()) {
            SysAttViewerUtil.logger.debug("系统地址:" + urlPrefix);
        }
        final long expires = System.currentTimeMillis() + 180000L;
        final String sign = getRestSign(sysAttMain.getFdId(), expires);
        final String downLoadUrl = String.valueOf(urlPrefix) + "/sys/attachment/sys_att_main/downloadFile.jsp?fdId=" + sysAttMain.getFdId() + "&Expires=" + expires + "&Signature=" + sign + "&reqType=rest&filename=" + URLEncoder.encode(sysAttMain.getFdFileName(), "utf-8");
        return downLoadUrl;
    }
    
    public static String getUploadUrl(final SysAttMain sysAttMain) throws Exception {
        if (!TokenGenerator.isInitialized()) {
            String zdWebContentPath = ConfigLocationsUtil.getKmssConfigPath();
            if (StringUtil.isNotNull(zdWebContentPath)) {
                zdWebContentPath = String.valueOf(zdWebContentPath) + "/LRToken";
            }
            TokenGenerator.loadFromKeyFile(zdWebContentPath);
        }
        final Token token = TokenGenerator.getInstance().generateTokenByUserName(UserUtil.getUser().getFdLoginName());
        String urlPrefix = ResourceUtil.getKmssConfigString("kmss.urlPrefix");
        if (urlPrefix.endsWith("/")) {
            urlPrefix = urlPrefix.substring(0, urlPrefix.lastIndexOf("/"));
        }
        final String uploadUri = String.valueOf(urlPrefix) + "/sys/attachment/uploadFile.do?" + "userId=" + UserUtil.getUser().getFdId() + "&fdId=" + sysAttMain.getFdId() + "&wpsOasisstToken=" + token.toString();
        return uploadUri;
    }
    
    private static String getRestSign(final String attMainId, final long expires) throws Exception {
        final String signStr = String.valueOf(expires) + ":" + attMainId;
        final ISysRestserviceServerMainService sysRestMainService = (ISysRestserviceServerMainService)SpringBeanUtil.getBean("sysRestserviceServerMainService");
        final SysRestserviceServerMain sysRestserviceServerMain = sysRestMainService.findByServiceBean("sysAttachmentRestService");
        final List<SysRestserviceServerPolicy> webPolicys = sysRestserviceServerMain.getFdPolicy();
        if (ArrayUtil.isEmpty((List)webPolicys)) {
            return "";
        }
        final SysRestserviceServerPolicy webPolicy = webPolicys.get(0);
        final String sign = SignUtil.getHMAC(String.valueOf(signStr) + ":" + webPolicy.getFdLoginId(), StringUtil.isNotNull(webPolicy.getFdPassword()) ? webPolicy.getFdPassword() : webPolicy.getFdId());
        return sign;
    }
    
    public static String getIconNameByAttName(final String fileFullName) {
        String attIconName;
        if (fileFullName.endsWith("pdf")) {
            attIconName = "pdf.png";
        }
        else if (fileFullName.endsWith("xls") || fileFullName.endsWith("xlsx")) {
            attIconName = "excel.png";
        }
        else if (fileFullName.endsWith("et")) {
            attIconName = "et.png";
        }
        else if (fileFullName.endsWith("doc") || fileFullName.endsWith("docx")) {
            attIconName = "word.png";
        }
        else if (fileFullName.endsWith("wps")) {
            attIconName = "wps.png";
        }
        else if (fileFullName.endsWith("ppt") || fileFullName.endsWith("pptx")) {
            attIconName = "ppt.png";
        }
        else if (fileFullName.endsWith("zip")) {
            attIconName = "zip.png";
        }
        else if (fileFullName.endsWith("rar")) {
            attIconName = "rar.png";
        }
        else if (fileFullName.endsWith("7z")) {
            attIconName = "7z.png";
        }
        else if (fileFullName.endsWith("gif")) {
            attIconName = "gif.png";
        }
        else if (fileFullName.endsWith("html")) {
            attIconName = "html.png";
        }
        else if (fileFullName.endsWith("jpg")) {
            attIconName = "jpg.png";
        }
        else if (fileFullName.endsWith("ofd")) {
            attIconName = "ofd.png";
        }
        else if (fileFullName.endsWith("png")) {
            attIconName = "png.png";
        }
        else if (fileFullName.endsWith("txt")) {
            attIconName = "text.png";
        }
        else if (fileFullName.endsWith("png") || fileFullName.endsWith("jpg") || fileFullName.endsWith("jpeg") || fileFullName.endsWith("jpe") || fileFullName.endsWith("jxr") || fileFullName.endsWith("tif") || fileFullName.endsWith("tiff") || fileFullName.endsWith("bmp")) {
            attIconName = "image.png";
        }
        else {
            attIconName = "default.gif";
        }
        return attIconName;
    }
    
    private static class FileViewer
    {
        private String fileId;
        private String converterKey;
        private String viewerKey;
        private String viewerPath;
        private String[] extName;
        private Integer order;
        private String viewerParam;
        private String fdHighFidelity;
        
        public String getFileId() {
            return this.fileId;
        }
        
        public void setFileId(final String fileId) {
            this.fileId = fileId;
        }
        
        public String getConverterKey() {
            return this.converterKey;
        }
        
        public void setConverterKey(final String converterKey) {
            this.converterKey = converterKey;
        }
        
        public String getViewerKey() {
            return this.viewerKey;
        }
        
        public void setViewerKey(final String viewerKey) {
            this.viewerKey = viewerKey;
        }
        
        public String getViewerPath() {
            return this.viewerPath;
        }
        
        public void setViewerPath(final String viewerPath) {
            this.viewerPath = viewerPath;
        }
        
        public String[] getExtName() {
            return this.extName;
        }
        
        public void setExtName(final String[] extName) {
            this.extName = extName;
        }
        
        public Integer getOrder() {
            return this.order;
        }
        
        public void setOrder(final Integer order) {
            this.order = order;
        }
        
        public String getViewerParam() {
            return this.viewerParam;
        }
        
        public void setViewerParam(final String viewerParam) {
            this.viewerParam = viewerParam;
        }
        
        public String getFdHighFidelity() {
            return this.fdHighFidelity;
        }
        
        public void setFdHighFidelity(final String fdHighFidelity) {
            this.fdHighFidelity = fdHighFidelity;
        }
    }
}
